<?php
/*
* 2007-2012 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2012 PrestaShop SA
*  @version  Release: $Revision: 15094 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class UlozenkapayValidationModuleFrontController extends ModuleFrontController
{
	/**
	 * @see FrontController::postProcess()
	 */
	public function postProcess()
	{
		$cart = $this->context->cart;
		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
			Tools::redirect('index.php?controller=order&step=1');

		// Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
		$authorized = false;
		foreach (Module::getPaymentModules() as $module)
			if ($module['name'] == 'ulozenkapay')
			{
				$authorized = true;
				break;
			}
		if (!$authorized)
			die($this->module->l('This payment method is not available.', 'validation'));

		$customer = new Customer($cart->id_customer);
		if (!Validate::isLoadedObject($customer))
			Tools::redirect('index.php?controller=order&step=1');

		$currency = $this->context->currency;
		$total = (float)$cart->getOrderTotal(true, Cart::BOTH);
 
		$mailVars = array(
			'{selected_store}' => $this->compilePobocka(),
			
		);

		$this->module->validateOrder($cart->id, Configuration::get('ULOZENKA_OS_STATE'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer->secure_key);
		Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
	}
   
   protected function compilePobocka() {
       $pobocka= $this->getSelectedStore();
       $retval="<a href='{$pobocka['odkaz']}' target='_blank'>{$pobocka['nazev']}</a><br />
       {$pobocka['psc']} {$pobocka['obec']}<br />
       {$pobocka['ulice']}<br />
       {$pobocka['provoz']}<br />";
       
       return $retval;
   } 
    protected function getSelectedStore() {
             $code=Context::getContext()->cookie->{$this->name};
            include_once(_PS_MODULE_DIR_.'ulozenka/ulozenka.php');
            $pobocky=Ulozenka::getItemsStatic();
            if($code && strlen($code)) {
                foreach($pobocky as $pobocka) {
                    if($pobocka['zkratka'] == $code) {
                         return $pobocka;
                         break;
                    }
                }
            }
        return $pobocky[0];     
    }
}
