<?php
/*
* 2007-2012 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2012 PrestaShop SA
*  @version  Release: $Revision: 7095 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
* 
* modificatoons by prestahost.cz/prestahost.eu
* Sept. 2012
* allows carrier selection
* 
* compatibility Prestashop 1.5
* 
*/

if (!defined('_PS_VERSION_'))
	exit;

class UlozenkaPay extends PaymentModule
{
	private $_html = '';
	private $_postErrors = array();
    protected  $allowed_carriers = false;

	public $extra_mail_vars;
	public function __construct()
	{
		$this->name = 'ulozenkapay';
		$this->tab = 'payments_gateways';
		$this->version = '1.5';
		$this->author = 'Prestahost.eu';
		
		$this->currencies = true;
		$this->currencies_mode = 'checkbox';


		parent::__construct();
       $c= Configuration::get('ULOZENKAPAY_CARRIERS');
         if(!empty($c)) {
           $this->allowed_carriers=unserialize(Configuration::get('ULOZENKAPAY_CARRIERS'));  
        }
        
		$this->displayName = $this->l('Pay at Ulozenka');
		$this->description = $this->l('Accept payments at ulozenka.');
		
				if (!count(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');
     //  $items=Ulozenka::getItemsStatic();
	
                                        
                                     
	}

   


      public function install()
    {   
       
      if (!parent::install()
            OR !$this->registerHook('payment')
            OR !$this->registerHook('paymentReturn')
              OR !$this->registerHook('actionCarrierUpdate') 
            )
            return false;  

        
             $values=array(
             'id_order_state'=>null,
             'invoice'=>1,
             'send_email'=>1,
             'color'=>'#FFC3C3', 
             'unremovable'=>0
             );
  
             Db::getInstance()->autoExecuteWithNullValues('ps_order_state',$values,'INSERT');
             
             $lastid=Db::getInstance()->Insert_ID();
             if($lastid) {
                 Configuration::updateValue('ULOZENKA_OS_STATE', $lastid, 0, 0 );
                   $translations=array('cs'=>'V přípravě - Uloženka'); 
                 $langs=Language::getLanguages();
                 foreach($langs as $lang) {
                   $name=isset($translations[$lang['iso_code']])?$translations[$lang['iso_code']]:'Awaiting  payment - Uloženka';
                   $values=array(
                 'id_order_state'=>$lastid,
                  'id_lang'=>$lang['id_lang'],
                  'name'=>pSQL($name),
                  'template'=>pSQL($this->name), 
                 );
                  Db::getInstance()->AutoExecute('ps_order_state_lang',$values,'INSERT');
                 
                 }  
                 
           
             }
        
      
         
        $langs=array('en','cs');
        foreach($langs as $lan) {
            $dir=_PS_MODULE_DIR_.$this->name.'/mails/'.$lan;  
           
             
            if(file_exists($dir) &&   is_dir($dir)) {
                $maildir=  _PS_MAIL_DIR_.$lan;
                 if(file_exists($maildir) &&   is_dir($maildir)) { 
               if(!copy($dir.'/'.$this->name.'.html',  _PS_MAIL_DIR_.'/'.$lan.'/'.$this->name.'.html') 
            ||  !copy($dir.'/'.$this->name.'.txt',  _PS_MAIL_DIR_.'/'.$lan.'/'.$this->name.'.txt')) {
                    $this->_errors[]='Failed to copy email templates from '.$dir . ' to '._PS_MAIL_DIR_.$lan;   
                   
                    if(!is_writable(_PS_MAIL_DIR_.$lan))
                     $this->_errors[]= _PS_MAIL_DIR_.$lan.' not writable';
                    if(! file_exists($dir.'/'.$this->name.'.html',  _PS_MAIL_DIR_.'/'.$lan.'/'.$this->name.'.html'))
                     $this->_errors[] =$dir.'/'.$this->name.'.html does not exist';
                    
                     if(! file_exists($dir.'/'.$this->name.'.txt',  _PS_MAIL_DIR_.'/'.$lan.'/'.$this->name.'.html'))
                     $this->_errors[] =$dir.'/'.$this->name.'.txt does not exist';
               
                    return false;
            }  
            }
            }
        }
        return true;
       
    }
 
    
    public function uninstall()
    {   
        
        $langs=array('en','cs');
        foreach($langs as $lan) {
              
               $file=_PS_MAIL_DIR_.$lan.'/'.$this->name.'.html';
               if(file_exists($file))
                 unlink($file);
                $file=_PS_MAIL_DIR_.$lan.'/'.$this->name.'.txt';
               if(file_exists($file))
                 unlink($file);   
        }       
        
        
        $where='id_order_state='.Configuration::get('ULOZENKA_OS_STATE');
        Configuration::deleteByName('ULOZENKAPAY_CARRIERS');
        Configuration::deleteByName('ULOZENKA_OS_STATE');
         
        if (  !parent::uninstall()
             OR ! Db::getInstance()->delete('ps_order_state_lang', $where)
             OR ! Db::getInstance()->delete('ps_order_state', $where,1)   
                
        )
            return false;
       
             
        return true;    
     
    }  
   


	private function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
		;
		}
	}

	private function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{

            $carrier=Tools::getValue('carrier');
            if(!empty($carrier) && is_array($carrier)) {
                 $this->allowed_carriers =array_keys($carrier);
                 Configuration::updateValue('ULOZENKAPAY_CARRIERS', serialize($this->allowed_carriers ));  
            }
            else 
            {
                 $this->allowed_carriers =array();
                 Configuration::updateValue('ULOZENKAPAY_CARRIERS', null ); 
            }   
            
		}
		$this->_html .= '<div class="conf confirm"> '.$this->l('Settings updated').'</div>';
	}

	private function _displayUlozenka()
	{
		$this->_html .= '<img src="../modules/'.$this->name.'/ulozenkapay.jpg" style="float:left; margin-right:15px;"><b>'.$this->l('This module allows you to accept payments at ulozenka.').'</b><br /><br />

	   <br /><br />';
        $this->_html .='<br /><br /><a href="http://www.prestahost.cz" target="_blank"><img src="../modules/'.$this->name.'/prestahost.gif"></a> 
       <br />  
       <b><a href="http://www.prestahost.cz" target="_blank">Prestahost.cz</a> </b>: česká podpora Prestashopu, specializovaný hosting, moduly na míru, import xml feedů ...
          
        <br /> 
         <br /> ';  
        
      
	}

	private function _displayForm()
	{
		$this->_html .=
		'<form action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Settings').'</legend>
				<table border="0" width="500" cellpadding="0" cellspacing="0" id="form">';
					
                    
                  $this->_html .= '<tr><td>'.$this->l('Allowed carriers, leave empty for all').'</td><td>'.$this->fetchCarriers($this->allowed_carriers).'</td></tr>';
       
					$this->_html .='<tr><td colspan="2" align="center"><input class="button" name="btnSubmit" value="'.$this->l('Update settings').'" type="submit" /></td></tr>
				</table>
			</fieldset>
		</form>';
	}

	public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';

		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			if (!count($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors as $err)
					$this->_html .= '<div class="alert error">'.$err.'</div>';
		}
		else
			$this->_html .= '<br />';

		$this->_displayUlozenka();
		$this->_displayForm();

		return $this->_html;
	}

	public function hookPayment($params)
	{
		if (!$this->active)
			return;
		if (!$this->checkCurrency($params['cart']))
			return;
         if(!$this->isAllowedCarrier($params['cart']->id_carrier)) 
           return false;

		$this->smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_ssl' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/'
		));
		return $this->display(__FILE__, 'payment.tpl');
	}

	public function hookPaymentReturn($params)
	{
		if (!$this->active)
			return;

		$state = $params['objOrder']->getCurrentState();
		if ($state == Configuration::get('ULOZENKA_OS_STATE') || $state == Configuration::get('PS_OS_OUTOFSTOCK'))
		{
			$this->smarty->assign(array(
				'total_to_pay' => Tools::displayPrice($params['total_to_pay'], $params['currencyObj'], false),
				'status' => 'ok',
				'id_order' => $params['objOrder']->id
			));
			if (isset($params['objOrder']->reference) && !empty($params['objOrder']->reference))
				$this->smarty->assign('reference', $params['objOrder']->reference);
		}
		else
			$this->smarty->assign('status', 'failed');
		return $this->display(__FILE__, 'payment_return.tpl');
	}
	
	public function checkCurrency($cart)
	{
		$currency_order = new Currency($cart->id_currency);
		$currencies_module = $this->getCurrency($cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}
    
    
    public function   hookActionCarrierUpdate($params) {
        $this->_renumberCarriers($params);
        Configuration::updateValue('ULOZENKAPAY_CARRIERS', serialize($this->allowed_carriers ));   
    }
    
 protected function isAllowedCarrier($id_carrier) {
     // no restriction if  allowed_carriers is empty
   
      if(!is_array($this->allowed_carriers) || !count($this->allowed_carriers))
        return true;
      
      if(in_array($id_carrier, $this->allowed_carriers))
          return true;
          
        return false;
    }
    
    protected function fetchCarriers($selected) {
     $id_lang=Configuration::get(PS_LANG_DEFAULT);   
        $carriers=Carrier::getCarriers($id_lang, true, false, false, null,Carrier::ALL_CARRIERS); 
       $retval='';
       foreach ($carriers as $carrier) {
           $retval.= "<input type='checkbox' name='carrier[{$carrier['id_carrier']}]' value='{$carrier['id_carrier']}'";
           if(is_array($selected) && in_array($carrier['id_carrier'], $selected))
            $retval.=' checked="checked"';
           
           $retval.="/>".$carrier['name'].'<br />';
       }
       return $retval;
    }
    
    
    protected function _renumberCarriers($params) {
         if($params['carrier']->id && ($params['carrier']->id != $params['id_carrier']) && is_array($this->allowed_carriers)   ){
           $carriers=array();
           foreach($this->allowed_carriers as $carrier) {
               $carriers[]=($carrier==$params['id_carrier'])?$params['carrier']->id:$carrier;
               
           }
           $this->allowed_carriers=$carriers;
         }
    } 

}
